SystemOrganization addCategory: #'TP-Metaprogramacion'!

Object subclass: #IVDelegator
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP-Metaprogramacion'!

!IVDelegator class methodsFor: 'initialize-release' stamp: 'Leo 11/3/2013 18:34'!
on: anObject

	|instance|
	instance := IVDelegator new.
	instance initialize:anObject.
	^ instance! !

!IVDelegator methodsFor: 'initialize-release' stamp: 'Leo 11/3/2013 18:43'!
initialize: anObject
	
	object := anObject.! !

!IVDelegator methodsFor: 'accessing' stamp: 'Leo 11/3/2013 18:44'!
object
	
	^ object! !

!IVDelegator methodsFor: 'accessing' stamp: 'Leo 11/3/2013 18:44'!
object: anObject
	
	object := anObject! !

!IVDelegator methodsFor: 'methods' stamp: 'Leo 11/3/2013 21:34'!
sendMessage: aMessage
	
	|vars values|
	(object respondsTo: aMessage)
		ifTrue: [^object perform: aMessage.]
		ifFalse:[
			vars := object class instVarNames.
			values :=  vars collect: [ :v | object perform: v asSymbol ].
			^  self sendMessage: aMessage toVars:values.
			]! !

!IVDelegator methodsFor: 'methods' stamp: 'Leo 11/3/2013 20:29'!
sendMessage: aMessage toVars: vars
	"comment stating purpose of message"

	|target|
	
	(vars anySatisfy: [ :v | v respondsTo: aMessage ] )
		ifTrue: [target := vars detect: [ :v | v respondsTo: aMessage ].
 				^target perform: aMessage.]
		ifFalse:[^Exception signal: 'Not found an object that can responds a message'.]! !

!IVDelegator methodsFor: 'methods' stamp: 'Leo 11/3/2013 21:31'!
sendMessage: aMessage with: arg
	"comment stating purpose of message"

	|vars values|
	(object respondsTo: aMessage)
		ifTrue: [^object perform: aMessage with: arg.]
		ifFalse:[
			vars := object class instVarNames.
			values :=  vars collect: [ :v | object perform: v asSymbol ].
			^  self sendMessage: aMessage with: arg toVars:values]! !

!IVDelegator methodsFor: 'methods' stamp: 'Leo 11/3/2013 21:25'!
sendMessage: aMessage with: arg toVars:vars

	|target|
	
	(vars anySatisfy: [ :v | v respondsTo: aMessage ] )
		ifTrue: [target := vars detect: [ :v | v respondsTo: aMessage ].
 				^target perform: aMessage with:arg.]
		ifFalse:[^Exception signal: 'Not found an object that can responds a message'.]! !

!IVDelegator methodsFor: 'methods' stamp: 'Leo 11/3/2013 21:36'!
sendMessage: aMessage withArguments: args
	"comment stating purpose of message"

	|vars values|
	(object respondsTo: aMessage)
		ifTrue: [
			(aMessage isUnary)
				ifTrue:[^object perform: aMessage]
				ifFalse:[^object perform: aMessage withArguments: args ]
			]
		ifFalse:[
			vars := object class instVarNames.
			values :=  vars collect: [ :v | object perform: v asSymbol ].
			^  self sendMessage: aMessage withArguments: args toVars:values.
			]! !

!IVDelegator methodsFor: 'methods' stamp: 'Leo 11/3/2013 21:25'!
sendMessage: aMessage withArguments: args toVars:vars

	|target|
	
	(vars anySatisfy: [ :v | v respondsTo: aMessage ] )
		ifTrue: [target := vars detect: [ :v | v respondsTo: aMessage ].
 				^target perform: aMessage withArguments:args.]
		ifFalse:[^Exception signal: 'Not found an object that can responds a message'.]! !

Object subclass: #Interface
	instanceVariableNames: 'interface'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP-Metaprogramacion'!

!Interface class methodsFor: 'methods' stamp: 'Ariel 11/1/2013 17:41'!
create: aSelectors
|instance|
instance := Interface new.
instance initialize: aSelectors.
^ instance.! !

!Interface methodsFor: 'methods' stamp: 'Ariel 11/3/2013 17:49'!
addNeededStubIn: aClass
	"Add all methods unimplemented by aClass that contains self in aClass"
	|unaries unimplemented|
	unaries := interface select: [ :m | m isUnary ].
	unimplemented := unaries reject: [ :m | aClass canUnderstand: m ].
	unimplemented do: [ :m | self addUnimplementedMethod: m in: aClass ].! !

!Interface methodsFor: 'methods' stamp: 'Ariel 11/3/2013 18:01'!
addUnimplementedMethod: aMethod in: aClass
	" Compile aMethods and add this in aClass. "
	aClass compile: (aMethod, Character cr asString, Character tab asString,  '^ nil').! !

!Interface methodsFor: 'initialize-release' stamp: 'Ariel 11/1/2013 17:56'!
initialize: aSelectors

interface := aSelectors.! !

!Interface methodsFor: 'methods' stamp: 'Ariel 11/1/2013 17:55'!
isCompliant: aClass
   	"Return if aClass have all selectors includes in self"
 
	^ interface allSatisfy: [ :m | aClass allSelectors includes: m ]! !

!Interface methodsFor: 'methods' stamp: 'Ariel 11/1/2013 17:58'!
isUnderstoodBy: anObject
"Return if anObject responds to all selectors of self"

	^ interface allSatisfy: [ :m | anObject respondsTo: m ]! !

!Interface methodsFor: 'methods' stamp: 'Ariel 11/3/2013 17:41'!
query: anObject
	"Return a dictionary that is the result of send all unaries messages of interface that understand anObject to anObject.
	The key is the selector of message and the value is the return of this. "
	|unaries understand dictionary|
	unaries := interface select: [ :m | m isUnary ].
	understand := unaries select: [ :m | anObject  respondsTo: m].
	dictionary := Dictionary new. 
	understand do: [ :m | dictionary at: m put: anObject m ].
	
	^ dictionary. ! !

Object subclass: #MockClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP-Metaprogramacion'!

!MockClass methodsFor: 'private' stamp: 'Ariel 11/3/2013 18:27'!
removeAllMethodsNotPrivate

	|private methods|
	private := #removeAllMethodsNotPrivate.
	methods := self class selectors .
	methods reject: [ :m | m == private ].
	methods do: [ :m | self class removeSelector: m ].! !

TestCase subclass: #TestInterface
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP-Metaprogramacion'!

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:38'!
test_addNeededStubIn_andAddMethod2

	| interface setOfMethods |
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass.
	
	interface addNeededStubIn: MockClass.
	
	self should: [ MockClass canUnderstand: #method2 ].
	
	MockClass removeSelector: #method2.
	MockClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:38'!
test_isComplaint_andReturnFalse

	|interface setOfMethods|
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass .

	self should: [ (interface isCompliant: MockClass) not ].
	MockClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:33'!
test_isComplaint_andReturnTrue

	|interface setOfMethods|
	setOfMethods := Set new.
	setOfMethods add: #method1.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass .

	self should: [ interface isCompliant: MockClass ].
	MockClass removeSelector: #method1.! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:35'!
test_isUnderstoodBy_andReturnFalse

	|interface mock setOfMethods|
	mock:= MockClass new.
	setOfMethods := Set new.
	setOfMethods add: #method1 ; add: #method2.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass . 
	
	self should: [ (interface isUnderstoodBy: mock) not]! !

!TestInterface methodsFor: 'tests' stamp: 'Ariel 11/3/2013 23:32'!
test_isUnderstoodBy_andReturnTrue

	|interface mock setOfMethods|
	mock:= MockClass new.
	setOfMethods := Set new.
	setOfMethods add: #method1.
	interface := Interface create: setOfMethods .
	interface addUnimplementedMethod: #method1 in: MockClass . 
	
	self should: [ interface isUnderstoodBy: mock ]! !
